--- misc.lisp.org	2011-02-07 14:46:15.000000000 +0900
+++ misc.lisp	2011-02-07 14:53:57.000000000 +0900
@@ -154,16 +154,34 @@
                      :direction :input
                      :element-type 'octet
                      :if-does-not-exist nil)
-      (setf (header-out :last-modified) (rfc-1123-date time)
-            (content-length*) (file-length file))
-      (let ((out (send-headers)))
-        #+:clisp
-        (setf (flexi-stream-element-type *hunchentoot-stream*) 'octet)
-        (loop with buf = (make-array +buffer-length+ :element-type 'octet)
-              for pos = (read-sequence buf file)
-              until (zerop pos)
-              do (write-sequence buf out :end pos)
-                 (finish-output out))))))
+      (let ((max (1- (file-length file)))
+            (min 0)
+            (v nil))
+        (when (and (header-in* :range)
+                   (string= (header-in* :range) "bytes" :end1 5))
+          (setf v (nth-value 1 (scan-to-strings "([0-9]*)-([0-9]*)" (header-in* :range)))
+                min (if (zerop (length (elt v 0)))
+                      0
+                      (parse-integer (elt v 0) :junk-allowed t))
+                max (if (zerop (length (elt v 1)))
+                      (1- (file-length file))
+                      (parse-integer (elt v 1) :junk-allowed t))
+                (return-code*) +http-partial-content+
+                (header-out :accept-ranges) "bytes"
+                (header-out :content-range) (format nil "bytes ~D-~D/~D" min max (file-length file))))
+        (setf (header-out :last-modified) (rfc-1123-date time)
+              (content-length*) (- max min -1))
+        (let* ((*approved-return-codes* (cons +http-partial-content+ *approved-return-codes*))
+               (out (send-headers)))
+          #+:clisp
+          (setf (flexi-stream-element-type *hunchentoot-stream*) 'octet)
+          (file-position file min)
+          (loop with buf = (make-array +buffer-length+ :element-type 'octet)
+                for pos = (read-sequence buf file)
+                for rest = (- max min -1) then (- rest pos)
+                until (or (zerop pos) (<= rest 0))
+                do (write-sequence buf out :end (if (> rest pos) pos rest))
+                   (finish-output out)))))))
 
 (defun create-static-file-dispatcher-and-handler (uri path &optional content-type)
   "Creates and returns a request dispatch function which will dispatch
